AWS IoT Device SDK C++ v2: Aws::Crt::Http::HttpStream Class Reference

AWS IoT Device SDK C++ v2 1.14.0 AWS IoT Device SDK C++ v2

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
Aws::Crt::Http::HttpStream Class Referenceabstract

`#include <HttpConnection.h>`

Inheritance diagram for Aws::Crt::Http::HttpStream:

## Public Member Functions
virtual | ~HttpStream ()
| HttpStream (const HttpStream &)=delete
| HttpStream (HttpStream &&)=delete
HttpStream & | operator= (const HttpStream &)=delete
HttpStream & | operator= (HttpStream &&)=delete
HttpClientConnection & | GetConnection () const noexcept
virtual int | GetResponseStatusCode () const noexcept=0
void | UpdateWindow (std::size_t incrementSize) noexcept

## Protected Member Functions
| HttpStream (const std::shared_ptr< HttpClientConnection > &connection) noexcept

## Protected Attributes
aws_http_stream * | m_stream
std::shared_ptr< HttpClientConnection > | m_connection

## Friends
class | HttpClientConnection

## Detailed Description

Represents a single http message exchange (request/response) or in H2, it can also represent a PUSH_PROMISE followed by the accompanying Response.

## Constructor & Destructor Documentation

## ◆ ~HttpStream()

Aws::Crt::Http::HttpStream::~HttpStream | ( |  | ) |
| virtual

## ◆ HttpStream() [1/3]

Aws::Crt::Http::HttpStream::HttpStream | ( | const HttpStream & |  | ) |
| delete

## ◆ HttpStream() [2/3]

Aws::Crt::Http::HttpStream::HttpStream | ( | HttpStream && |  | ) |
| delete

## ◆ HttpStream() [3/3]

Aws::Crt::Http::HttpStream::HttpStream | ( | const std::shared_ptr< HttpClientConnection > & | connection | ) |
| protectednoexcept

## Member Function Documentation

## ◆ GetConnection()

HttpClientConnection & Aws::Crt::Http::HttpStream::GetConnection | ( |  | ) | const
| noexcept

Get the underlying connection for the stream.

## ◆ GetResponseStatusCode()

virtual int Aws::Crt::Http::HttpStream::GetResponseStatusCode | ( |  | ) | const
| pure virtualnoexcept

Returns
  request's Http Response Code. Requires response headers to have been processed first. *

Implemented in Aws::Crt::Http::HttpClientStream.

## ◆ operator=() [1/2]

HttpStream & Aws::Crt::Http::HttpStream::operator= | ( | const HttpStream & |  | ) |
| delete

## ◆ operator=() [2/2]

HttpStream & Aws::Crt::Http::HttpStream::operator= | ( | HttpStream && |  | ) |
| delete

## ◆ UpdateWindow()

void Aws::Crt::Http::HttpStream::UpdateWindow | ( | std::size_t | incrementSize | ) |
| noexcept

Updates the read window on the connection. In Http 1.1 this relieves TCP back pressure, in H2 this will trigger two WINDOW_UPDATE frames, one for the connection and one for the stream.

You do not need to call this unless you utilized the `outWindowUpdateSize` in `OnIncomingBody`. See `OnIncomingBody` for more information.

`incrementSize` is the amount to update the read window by.

## Friends And Related Function Documentation

## ◆ HttpClientConnection

friend class HttpClientConnection
| friend

## Member Data Documentation

## ◆ m_connection

std::shared_ptr<HttpClientConnection> Aws::Crt::Http::HttpStream::m_connection
| protected

## ◆ m_stream

aws_http_stream* Aws::Crt::Http::HttpStream::m_stream
| protected

The documentation for this class was generated from the following files:

- crt/aws-crt-cpp/include/aws/crt/http/HttpConnection.h
- crt/aws-crt-cpp/source/http/HttpConnection.cpp